
#ifndef INC_BUFFER_H
#define INC_BUFFER_H

#include "furytypes.h"

/* buffering system */
typedef struct stBUFFER {
	int		total_size;		/* size of buffer in bytes */
	int		read_index;		/* where our pointer is */
	int		write_index;		/* where we write */
	int		dirty;			/* buffer is dirty or not */
	BYTE		*data;			/* pointer to data */
} BUFFER;


/* protos */
void		buffer_get_all(BUFFER *buf, BYTE **ptr, int *len);
int		buffer_insert(BUFFER *buf, BYTE *data, int datalen);
int		buffer_get(BUFFER *buf, BYTE *data, int datalen);
int		buffer_insertb(BUFFER *buf, BYTE ch);
int		buffer_getb(BUFFER *buf, BYTE *ch);
int		create_buffer(BUFFER *buf, int size);
void		free_buffer(BUFFER *buf);
void		buffer_clear(BUFFER *buf);

#define buffer_used(x) 		(x->write_index - x->read_index)
#define buffer_available(x) 	(x->total_size - (x->write_index - x->read_index))
#define buffer_dirty(x) 	((x)->dirty != 0)
#define buffer_empty(x) 	((x->write_index - x->read_index) == 0)

#endif
