/*
** ipx.h - holds the structures in an IPX frame
**
** Keith Zaback (krz@wcug.wwu.edu) Apr 98
*/

#ifndef INC_IPX_H
#define INC_IPX_H

/* ipx structs */
typedef struct stIPXADDR {
	unsigned int	network;
	unsigned char	host[6];
	unsigned short	port;
} IPXADDR;

typedef struct stIPXHEADER {
	unsigned short		checksum;
	unsigned short		length;
	unsigned char		control;
	unsigned char		type;
	IPXADDR			ipx_dest __attribute__ ((packed));
	IPXADDR			ipx_src __attribute__ ((packed));
} IPXHEADER;

/* only the vital stuff (SQ = squished) */
typedef struct stIPXHEADER_SQ {
	unsigned short		length;
	unsigned char		src_host[6] __attribute__ ((packed));
	unsigned short		src_port __attribute__ ((packed));
	unsigned char		dest_host[6] __attribute__ ((packed));
	unsigned short		dest_port __attribute__ ((packed));
} IPXHEADER_SQ;

#endif
