/*
** pktcache.h 	- header for the routines for caching of packet data
**
** Keith Zaback (krz@wcug.wwu.edu) Apr 98
*/

#ifndef INC_PKTCACHE_H
#define INC_PKTCACHE_H

#include "defaults.h"
#include "furytypes.h"
#include "fury.h"


/* the packet cache entry */
typedef struct stPKTCACHE_ENTRY {
	IPXADDR		address;	/* the source:port */
	int		data_length;	/* how many bytes in the data are good */
	BYTE		data[FURY_FRAME_MAX_DATA];	/* actual data */
	int		used;		/* # of times this one has been used */
	int		clear_req;	/* how many clear req */
} PKTCACHE_ENTRY;


/* protos */
int		pktcache_hash(PKTCACHE_ENTRY *entry);
int		pktcache_compare(PKTCACHE_ENTRY *e1, PKTCACHE_ENTRY *e2);
void		pktcache_hash_enum(int bucket, PKTCACHE_ENTRY *entry);

#endif
