/*
** porttable.c - thing for fast port number look ups
**
** Keith Zaback (krz@wcug.wwu.edu) Apr 98
*/

#include "ipxfury.h"
#include <stdlib.h>
#include <string.h>


/*
**	SHOW_SET_PORTS - prints a list of set ports
*/
void show_set_ports(PORT_TABLE tab)
{
	int		pno, run;
	int		i;
	
	
	i = 0;
	pno = 0;
	while( pno < 0x10000 ) {
		/* is this port set? */
		if( check_port(tab, pno) ) {
			/* yes, so print it out */
			notice("%d", pno);
			i++;
			if( i > 11 ) {
				notice("\n");
				i = 0;
			}
			/* check for a "run" of ports */
			run = pno+1;
			while( (check_port(tab, run)) && (run < 0x10000) ) {
				run++;
			}
			/* where did the run end? */
			if( run == (pno+1) ) {
				/* there was no run */
				notice(", ");
			} else if( run == (pno+2) ) {
				/* only 1 port followed */
				notice(", %d, ", (pno+1));
				i++;
			} else {
				/* run of many ports */
				notice("..%d, ", (run-1));
				i++;
			}
			/* adjust pno */
			pno = run;
			/* check for cleany */
			if( i > 11 ) {
				notice("\n");
				i = 0;
			}
		} else {
			/* this port is not set, just inc pno */
			pno++;
		}
	} /* while */

	/* one last check */
	if( i != 0 ) {
		notice("\n");
	}

}



/*
**	CREATE_PORT_TABLE
*/
PORT_TABLE create_port_table()
{
	PORT_TABLE	temp;
	
	/* alloc & clean */
	temp = (PORT_TABLE)malloc(PORT_TABLE_SIZE_BYTES);
	memset(temp, 0, PORT_TABLE_SIZE_BYTES);
	
	/* done */
	return( temp );
}


/*
**	FREE_PORT_TABLE
*/
void free_port_table(PORT_TABLE *tab)
{
	/* make sure it is valid then free */
	if( *tab != NULL )
		free(*tab);
	
	/* set it to NULL */	
	*tab = NULL;
}
	